#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <stdio.h>

#include "getstream.h"

int addr_is_mcast(char *addr) {
	struct in_addr	iaddr;
	inet_aton(addr, &iaddr);
	return IN_MULTICAST(iaddr.s_addr);
}

void dump_hex(uint8_t *buf, int size) {
	int		i;
	unsigned char	ch;
	char		sascii[17];

	sascii[16]=0x0;

	for(i=0;i<size;i++) {
		ch=buf[i];
		if (i%16 == 0) {
			fprintf(stderr, "%04x ", i);
		}
		fprintf(stderr, "%02x ", ch);
		if (ch >= ' ' && ch <= '}')
			sascii[i%16]=ch;
		else
			sascii[i%16]='.';

		if (i%16 == 15)
			fprintf(stderr, "   %s\n", sascii);
	}

	/* i++ after loop */
	if (i%16 != 0) {

		for(;i%16 != 0;i++) {
			fprintf(stderr, "   ");
			sascii[i%16]=' ';
		}

		fprintf(stderr, "   %s\n", sascii);
	}
	fprintf(stderr, "\n");
}

void ts_packet_decode(uint8_t *ts) {
	printf("ts_packet_decode\n");
	dump_hex(ts, TS_PACKET_SIZE);
	printf("\tsync: %02x\n", ts[0]);
	printf("\ttransport_error_indicator: %d\n", ts[1]&0x80 ? 1 : 0);
	printf("\tpayload_unit_start_indicator: %d\n", ts[1]&0x40 ? 1 : 0);
	printf("\ttransport_priority: %d\n", ts[1]&0x20 ? 1 : 0);
	printf("\tpid: %d\n", (ts[1]<<8|ts[2])&0x1fff);
	printf("\ttransport_scrambling_control: %d\n", (ts[3]>>6) & 0x3);
	printf("\tadaption_field_control: %d\n", (ts[3]>>4) & 0x3);
	printf("\tcontinuity_counter: %d\n", ts[3]&0xf);
}

